#ifndef AFX_ISTOOL_H__DC72C0F0_7D3A_4DFB_91E7_7C54A63A7FA1__INCLUDED_
#define AFX_ISTOOL_H__DC72C0F0_7D3A_4DFB_91E7_7C54A63A7FA1__INCLUDED_

#include "Tool.h"


class CIsTool : public CTool
{
//
// original source is
//
// i6comp v0.20 ( Dec-27-2000 )
//   ftp://ftp.externet.hu/pub/mirror/sac/pack/i6comp02.zip
// i5comp v2.01 ( Aug-24-1999 )
//   ftp://ftp.externet.hu/pub/mirror/sac/pack/i5comp21.rar
// 
// -] fOSSiL [-
// -] Morlac [-
//

public:

	CIsTool() : CTool( "InstallShield-Cab WJ" ){}

	bool IsType( const char* ext )
		{return 0==stricmp(ext,"hdr");}

	bool Check( const char* fname, unsigned long fsize );
	bool Extract( const char* fname, const char* ddir );

private:

	// wb_t@C̏ǂݎ
	bool readHeader();
	// o
	bool extractAll();
	void directCopy( bool crypt );
	void decompress();

	// }`{[̓ǂݏoJvZ
	int m_nextVol;
	int m_sizeLimit;
	bool readInit();
	int readArc( void* buf, int siz );

	// ɖێ
	void setupNamePattern( const char* fname );
	char m_arcNamePat[MAX_PATH*2];

	// t@Cnh
	bool openArc( int vol, const char* ext );
	void closeArc();
	FILE *fp, *wp;

	// i[t@C
	struct fileInf
	{
		char    name[MAX_PATH]; //O(pXt)
		__int64 cbExpanded;     //𓀌̃TCY
		__int64 cbCompressed;   //k̃TCY
		__int64 ofsData;        //f[^ʒu
		DWORD   attr;           //
		WORD    date, time;     //
		bool    cmprs, crypt;   //k?Í?
	};
	fileInf* m_FileList;
	int m_FileNum;

	static int __stdcall _r_(void* b, DWORD* s, CIsTool* p);
	static int __stdcall _w_(void* b, DWORD* s, CIsTool* p);
};

#endif
